# Time Editor (QGIS Plugin)

Time Editor is a [QGIS]-plugin to facilitate the editing of geometric features with 
time information encoded in its attributes. It provides workflows for editing and 
functions to check the spatial and temporal topology. 

It is developed at the [Hessische Institut für Landesgeschichte](https://hil.hessen.de) in 
order to reconstruct historical administrative boundaries. 

## How to use

### Sample Data 

We provide a sample data set to test this plugin with more complex historical data. You'll 
find a subset of our current historical boroughs dataset, licensed under [CC-BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/deed.en) [here](https://wms.hlgl.uni-marburg.de/public_downloads/schwalm_eder_gemarkung_master.zip)

### First time setup

After installation the plugin can be found under `Vector -> Time Editor`. You will need to select 
the Vector Layer you want to edit. The first time the Time-Editor starts it will ask you for 
the attribute field names for the primary key, the datestamp attributes, the documentation and 
the common identifier. If you use the sample dataset fill in the fields as in the following 
screenshot: 

![](doc_images/setup-test-data-schwalm-eder.png)

### Data integrity checks 

Once you have completed the basic setup you can perform integrity checks with `Vector -> Time Editor -> Inspect Layer`. The following image shows how the check works. It will iterate over all 
unique timestamps in the layers features. For each of those timestamps it will filter the features 
and  check for intersections between the subset. By default it will ignore small intersections under 0.1 square map units.  

![](doc_images/example-spatial-integrity-check.png)

### Filtering 

Using `Vector -> Time Editor -> Filter Date` you can provide a datestring to filter all features 
to a specific timestamp. The following pictures illustrates the result for the value `1920-01-01` and `1930-01-01`: 

![](doc_images/schwalm-eder-filter-1920.png)

![](doc_images/schwalm-eder-filter-1930.png)


